KDE 4.7 PyKDE API Reference

- KDE's Python API

# Node Class Reference

`from PyKDE4.khtml import *`

Namespace: DOM

## Detailed Description

The Node interface is the primary datatype for the entire Document Object Model. It represents a single node in the document tree. While all objects implementing the Node interface expose methods for dealing with children, not all objects implementing the Node interface may have children. For example, Text nodes may not have children, and adding children to such nodes results in a DOMException being raised.

The attributes nodeName , nodeValue and attributes are included as a mechanism to get at node information without casting down to the specific derived interface. In cases where there is no obvious mapping of these attributes for a specific nodeType (e.g., nodeValue for an Element or attributes for a Comment), this returns null . Note that the specialized interfaces may contain additional and more convenient mechanisms to get and set the relevant information.

## Enumerations
DocumentPosition | { DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_PRECEDING, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC }
NodeType | { ELEMENT_NODE, ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, ENTITY_REFERENCE_NODE, ENTITY_NODE, PROCESSING_INSTRUCTION_NODE, COMMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, DOCUMENT_FRAGMENT_NODE, NOTATION_NODE, XPATH_NAMESPACE_NODE }
## Methods
| __init__ (self)
| __init__ (self, DOM.Node other)
| addEventListener (self, DOM.DOMString type, DOM.EventListener listener, bool useCapture)
DOM.Node | appendChild (self, DOM.Node newChild)
| applyChanges (self)
DOM.NamedNodeMap | attributes (self)
DOM.NodeList | childNodes (self)
DOM.Node | cloneNode (self, bool deep)
unsigned | compareDocumentPosition (self, DOM.Node other)
bool | dispatchEvent (self, DOM.Event evt)
long | elementId (self)
DOM.Node | firstChild (self)
int _x, int _y, int height | getCursor (self, int offset)
QRect | getRect (self)
bool | hasAttributes (self)
bool | hasChildNodes (self)
long | index (self)
DOM.Node | insertBefore (self, DOM.Node newChild, DOM.Node refChild)
bool | isNull (self)
bool | isSupported (self, DOM.DOMString feature, DOM.DOMString version)
DOM.Node | lastChild (self)
DOM.DOMString | localName (self)
DOM.DOMString | namespaceURI (self)
DOM.Node | nextSibling (self)
DOM.DOMString | nodeName (self)
int | nodeType (self)
DOM.DOMString | nodeValue (self)
| normalize (self)
bool | operator != (self, DOM.Node other)
bool | operator == (self, DOM.Node other)
DOM.Document | ownerDocument (self)
DOM.Node | parentNode (self)
DOM.DOMString | prefix (self)
DOM.Node | previousSibling (self)
DOM.Node | removeChild (self, DOM.Node oldChild)
| removeEventListener (self, DOM.DOMString type, DOM.EventListener listener, bool useCapture)
DOM.Node | replaceChild (self, DOM.Node newChild, DOM.Node oldChild)
| setNodeValue (self, DOM.DOMString a0)
| setPrefix (self, DOM.DOMString prefix)
| setTextContent (self, DOM.DOMString text)
DOM.DOMString | textContent (self)
QString | toHTML (self)

## Method Documentation

__init__ | ( |  | self ) |

__init__ | ( | self, |
|  | DOM.Node | other
| ) |  |  |

addEventListener | ( | self, |
|  | DOM.DOMString | type,
|  | DOM.EventListener | listener,
|  | bool | useCapture
| ) |  |  |

Introduced in DOM Level 2 This method is from the EventTarget interface

This method allows the registration of event listeners on the event target. If an EventListener is added to an EventTarget while it is processing an event, it will not be triggered by the current actions but may be triggered during a later stage of event flow, such as the bubbling phase.

If multiple identical EventListeners are registered on the same EventTarget with the same parameters the duplicate instances are discarded. They do not cause the EventListener to be called twice and since they are discarded they do not need to be removed with the removeEventListener method. Parameters

Parameters:

  | type | The event type for which the user is registering
  | listener | The listener parameter takes an interface implemented by the user which contains the methods to be called when the event occurs.
  | useCapture | If true, useCapture indicates that the user wishes to initiate capture. After initiating capture, all events of the specified type will be dispatched to the registered EventListener before being dispatched to any EventTargets beneath them in the tree. Events which are bubbling upward through the tree will not trigger an EventListener designated to use capture.

DOM.Node appendChild | ( | self, |
|  | DOM.Node | newChild
| ) |  |  |

Adds the node newChild to the end of the list of children of this node. If the newChild is already in the tree, it is first removed.

Parameters:

  | newChild | The node to add.

If it is a DocumentFragment object, the entire contents of the document fragment are moved into the child list of this node

Returns:
  The node added.

DOMException HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the newChild node, or if the node to append is one of this node's ancestors.

WRONG_DOCUMENT_ERR: Raised if newChild was created from a different document than the one that created this node.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

applyChanges | ( |  | self ) |

DOM.NamedNodeMap attributes | ( |  | self ) |

A NamedNodeMap containing the attributes of this node (if it is an Element ) or null otherwise.

DOM.NodeList childNodes | ( |  | self ) |

A NodeList that contains all children of this node. If there are no children, this is a NodeList containing no nodes. The content of the returned NodeList is &quot;live&quot; in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the NodeList accessors; it is not a static snapshot of the content of the node. This is true for every NodeList , including the ones returned by the getElementsByTagName method.

DOM.Node cloneNode | ( | self, |
|  | bool | deep
| ) |  |  |

Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes. The duplicate node has no parent ( parentNode returns null .).

Cloning an Element copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child Text node. Cloning any other type of node simply returns a copy of this node.

Parameters:

  | deep | If true , recursively clone the subtree under the specified node; if false , clone only the node itself (and its attributes, if it is an

Element ).

Returns:
  The duplicate node.

unsigned compareDocumentPosition | ( | self, |
|  | DOM.Node | other
| ) |  |  |

Introduced in DOM Level 3.

This method compares the current node's position with that of 'other' and returns it as a combination of DocumentPosition bitfields. Here DOCUMENT_POSITION_FOLLOWING means that the 'other' is after the current.

The notion of order here is a logical one; for example attributes are viewed as if they were children of an element inserted right before the real children. The method will also assign some total order even if the nodes are not connected.

Since:
  4.2.4

bool dispatchEvent | ( | self, |
|  | DOM.Event | evt
| ) |  |  |

Introduced in DOM Level 2 This method is from the EventTarget interface

This method allows the dispatch of events into the implementations event model. Events dispatched in this manner will have the same capturing and bubbling behavior as events dispatched directly by the implementation. The target of the event is the EventTarget on which dispatchEvent is called.

Parameters:

  | evt | Specifies the event type, behavior, and contextual information to be used in processing the event.

Returns:
  The return value of dispatchEvent indicates whether any of the listeners which handled the event called preventDefault. If preventDefault was called the value is false, else the value is true.

EventException UNSPECIFIED_EVENT_TYPE_ERR: Raised if the Event's type was not specified by initializing the event before dispatchEvent was called. Specification of the Event's type as null or an empty string will also trigger this exception.

long elementId | ( |  | self ) |

Internal:
  not part of the DOM.

Returns:
  the element id, in case this is an element, 0 otherwise

DOM.Node firstChild | ( |  | self ) |

The first child of this node. If there is no such node, this returns null .

int _x, int _y, int height getCursor | ( | self, |
|  | int | offset
| ) |  |  |

Deprecated:
  without substitution since 3.2

QRect getRect | ( |  | self ) |

not part of the DOM.

Returns:
  the exact coordinates and size of this element.

bool hasAttributes | ( |  | self ) |

Returns whether this node (if it is an element) has any attributes.

Returns:
  a boolean. True if this node has any attributes, false otherwise. Introduced in DOM Level 2

bool hasChildNodes | ( |  | self ) |

This is a convenience method to allow easy determination of whether a node has any children.

Returns:
  true if the node has any children,

false if the node has no children.

long index | ( |  | self ) |

Internal:
  returns the index of a node

DOM.Node insertBefore | ( | self, |
|  | DOM.Node | newChild,
|  | DOM.Node | refChild
| ) |  |  |

Inserts the node newChild before the existing child node refChild . If refChild is null , insert newChild at the end of the list of children.

If newChild is a DocumentFragment object, all of its children are inserted, in the same order, before refChild . If the newChild is already in the tree, it is first removed.

Parameters:

  | newChild | The node to insert.
  | refChild | The reference node, i.e., the node before which the new node must be inserted.

Returns:
  The node being inserted.

DOMException HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the newChild node, or if the node to insert is one of this node's ancestors.

WRONG_DOCUMENT_ERR: Raised if newChild was created from a different document than the one that created this node.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NOT_FOUND_ERR: Raised if refChild is not a child of this node.

bool isNull | ( |  | self ) |

tests if this Node is 0. Useful especially, if casting to a derived class:

     Node n = .....;
     // try to convert into an Element:
     Element e = n;
     if( e.isNull() )
       kDebug() << "node isn't an element node";

bool isSupported | ( | self, |
|  | DOM.DOMString | feature,
|  | DOM.DOMString | version
| ) |  |  |

Introduced in DOM Level 2

Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.

Parameters:

  | feature | The name of the feature to test. This is the same name which can be passed to the method hasFeature on DOMImplementation.
  | version | This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return true.

Returns:
  Returns true if the specified feature is supported on this node, false otherwise.

DOM.Node lastChild | ( |  | self ) |

The last child of this node. If there is no such node, this returns null .

DOM.DOMString localName | ( |  | self ) |

Introduced in DOM Level 2

Returns the local part of the qualified name of this node. For nodes of any type other than ELEMENT_NODE and ATTRIBUTE_NODE and nodes created with a DOM Level 1 method, such as createElement from the Document interface, this is always null.

DOM.DOMString namespaceURI | ( |  | self ) |

Introduced in DOM Level 2

The namespace URI of this node, or null if it is unspecified. This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time. For nodes of any type other than ELEMENT_NODE and ATTRIBUTE_NODE and nodes created with a DOM Level 1 method, such as createElement from the Document interface, this is always null.

Note: Per the Namespaces in XML Specification [Namespaces] an attribute does not inherit its namespace from the element it is attached to. If an attribute is not explicitly given a namespace, it simply has no namespace.

DOM.Node nextSibling | ( |  | self ) |

The node immediately following this node. If there is no such node, this returns null .

DOM.DOMString nodeName | ( |  | self ) |

The name of this node, depending on its type; see the table above.

int nodeType | ( |  | self ) |

A code representing the type of the underlying object, as defined above.

DOM.DOMString nodeValue | ( |  | self ) |

The value of this node, depending on its type; see the table above.

DOMException DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a DOMString variable on the implementation platform.

normalize | ( |  | self ) |

Modified in DOM Level 2

Puts all Text nodes in the full depth of the sub-tree underneath this Node, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates Text nodes, i.e., there are neither adjacent Text nodes nor empty Text nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer [XPointer] lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains CDATASections, the normalize operation alone may not be sufficient, since XPointers do not differentiate between Text nodes and CDATASection nodes.

bool operator != | ( | self, |
|  | DOM.Node | other
| ) |  |  |

bool operator == | ( | self, |
|  | DOM.Node | other
| ) |  |  |

DOM.Document ownerDocument | ( |  | self ) |

The Document object associated with this node. This is also the Document object used to create new nodes. When this node is a Document this is null .

DOM.Node parentNode | ( |  | self ) |

The parent of this node. All nodes, except Document , DocumentFragment , and Attr may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, this is null .

DOM.DOMString prefix | ( |  | self ) |

Introduced in DOM Level 2

The namespace prefix of this node, or null if it is unspecified. Note that setting this attribute, when permitted, changes the nodeName attribute, which holds the qualified name, as well as the tagName and name attributes of the Element and Attr interfaces, when applicable. Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the namespaceURI and localName do not change. For nodes of any type other than ELEMENT_NODE and ATTRIBUTE_NODE and nodes created with a DOM Level 1 method, such as createElement from the Document interface, this is always null.

DOM.Node previousSibling | ( |  | self ) |

The node immediately preceding this node. If there is no such node, this returns null .

DOM.Node removeChild | ( | self, |
|  | DOM.Node | oldChild
| ) |  |  |

Removes the child node indicated by oldChild from the list of children, and returns it.

Parameters:

  | oldChild | The node being removed.

Returns:
  The node removed.

DOMException NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NOT_FOUND_ERR: Raised if oldChild is not a child of this node.

removeEventListener | ( | self, |
|  | DOM.DOMString | type,
|  | DOM.EventListener | listener,
|  | bool | useCapture
| ) |  |  |

Introduced in DOM Level 2 This method is from the EventTarget interface

This method allows the removal of event listeners from the event target. If an EventListener is removed from an EventTarget while it is processing an event, it will not be triggered by the current actions.

EventListeners can never be invoked after being removed.

Calling removeEventListener with arguments which do not identify any currently registered EventListener on the EventTarget has no effect.

Parameters:

  | type | Specifies the event type of the EventListener being removed.
  | listener | The EventListener parameter indicates the EventListener to be removed.
  | useCapture | Specifies whether the EventListener being removed was registered as a capturing listener or not. If a listener was registered twice, one with capture and one without, each must be removed separately. Removal of a capturing listener does not affect a non-capturing version of the same listener, and vice versa.

DOM.Node replaceChild | ( | self, |
|  | DOM.Node | newChild,
|  | DOM.Node | oldChild
| ) |  |  |

Replaces the child node oldChild with newChild in the list of children, and returns the oldChild node. If the newChild is already in the tree, it is first removed.

Parameters:

  | newChild | The new node to put in the child list.
  | oldChild | The node being replaced in the list.

Returns:
  The node replaced.

DOMException HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the newChild node, or it the node to put in is one of this node's ancestors.

WRONG_DOCUMENT_ERR: Raised if newChild was created from a different document than the one that created this node.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NOT_FOUND_ERR: Raised if oldChild is not a child of this node.

setNodeValue | ( | self, |
|  | DOM.DOMString | a0
| ) |  |  |

see nodeValue DOMException NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.

setPrefix | ( | self, |
|  | DOM.DOMString | prefix
| ) |  |  |

see prefix

DOMException INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NAMESPACE_ERR: Raised if the specified prefix is malformed, if the namespaceURI of this node is null, if the specified prefix is "xml" and the namespaceURI of this node is different from "http://www.w3.org/XML/1998/namespace", if this node is an attribute and the specified prefix is "xmlns" and the namespaceURI of this node is different from "http://www.w3.org/2000/xmlns/", or if this node is an attribute and the qualifiedName of this node is "xmlns" [Namespaces].

setTextContent | ( | self, |
|  | DOM.DOMString | text
| ) |  |  |

see textContent()

DOMException NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.

DOM.DOMString textContent | ( |  | self ) |

Introduced in DOM Level 3

This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. On setting, any possible children this node may have are removed and, if it the new string is not empty or null, replaced by a single Text node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed and the returned string does not contain the white spaces in element content (see the attribute Text.isElementContentWhitespace). Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.

QString toHTML | ( |  | self ) |

## Enumeration Documentation

DocumentPosition

Introduced in DOM Level 3.

These constants represent bitflags returned by the compareDocumentPosition method.

Since:
  4.2.4

Enumerator:

  DOCUMENT_POSITION_DISCONNECTED = 0x01 |
  DOCUMENT_POSITION_PRECEDING = 0x02 |
  DOCUMENT_POSITION_FOLLOWING = 0x04 |
  DOCUMENT_POSITION_CONTAINS = 0x08 |
  DOCUMENT_POSITION_CONTAINED_BY = 0x10 |
  DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC = 0x20 |

NodeType

An integer indicating which type of node this is.

The values of nodeName, nodeValue, and attributes vary according to the node type as follows: <table border="1"> <tr> <td></td> <td>nodeName</td> <td>nodeValue</td> <td>attributes</td> </tr> <tr> <td>Element</td> <td>tagName</td> <td>null</td> <td>NamedNodeMap</td> </tr> <tr> <td>Attr</td> <td>name of attribute</td> <td>value of attribute</td> <td>null</td> </tr> <tr> <td>Text</td> <td>#text</td> <td>content of the text node</td> <td>null</td> </tr> <tr> <td>CDATASection</td> <td>#cdata-section</td> <td>content of the CDATA Section</td> <td>null</td> </tr> <tr> <td>EntityReference</td> <td>name of entity referenced</td> <td>null</td> <td>null</td> </tr> <tr> <td>Entity</td> <td>entity name</td> <td>null</td> <td>null</td> </tr> <tr> <td>ProcessingInstruction</td> <td>target</td> <td>entire content excluding the target</td> <td>null</td> </tr> <tr> <td>Comment</td> <td>#comment</td> <td>content of the comment</td> <td>null</td> </tr> <tr> <td>Document</td> <td>#document</td> <td>null</td> <td>null</td> </tr> <tr> <td>DocumentType</td> <td>document type name</td> <td>null</td> <td>null</td> </tr> <tr> <td>DocumentFragment</td> <td>#document-fragment</td> <td>null</td> <td>null</td> </tr> <tr> <td>Notation</td> <td>notation name</td> <td>null</td> <td>null</td> </tr> </table>

Enumerator:

  ELEMENT_NODE = 1 |
  ATTRIBUTE_NODE = 2 |
  TEXT_NODE = 3 |
  CDATA_SECTION_NODE = 4 |
  ENTITY_REFERENCE_NODE = 5 |
  ENTITY_NODE = 6 |
  PROCESSING_INSTRUCTION_NODE = 7 |
  COMMENT_NODE = 8 |
  DOCUMENT_NODE = 9 |
  DOCUMENT_TYPE_NODE = 10 |
  DOCUMENT_FRAGMENT_NODE = 11 |
  NOTATION_NODE = 12 |
  XPATH_NAMESPACE_NODE = 13 |